"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Location(ProtocolElement):
    """
    Location of a variant which may be coordinates or an entity
    description if coordinates are not available. *
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import reports as reports_6_7_2

        return {
            "coordinates": reports_6_7_2.Coordinates,
            "entity": reports_6_7_2.GenomicEntity,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_3 import reports as reports_6_7_2

        return {
            "org.gel.models.report.avro.Coordinates": reports_6_7_2.Coordinates,
            "org.gel.models.report.avro.GenomicEntity": reports_6_7_2.GenomicEntity,
            "org.gel.models.report.avro.Location": reports_6_7_2.Location,
        }

    __slots__ = [
        "coordinates",
        "entity",
    ]

    def __init__(
        self,
        coordinates=None,
        entity=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_7_2.Location model.

        :param coordinates:
            Genomic coordinates of the variant if available
        :type coordinates: None | Coordinates
        :param entity:
            Entity description if coordinates are not available
        :type entity: None | GenomicEntity
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.7.2"
